unit TMSRemoteUnit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, OverbyteIcsWndControl, OverbyteIcsWSocket, Registry,
  jpeg, CyTools, Menus, ExtDlgs, INIFiles, XiProgressBar, IdBaseComponent,
  IdComponent, IdRawBase, IdRawClient, IdIcmpClient, TMSRemoteUnit2, Profiles,
  TMSRemoteUnit3, Clipbrd, System.Types, Vcl.Imaging.pngimage;

const
  DEFAULTBUFFERSIZE    = $100000;
  NRMACROBLOCKS        = 1620;
                                             //Power    Mute       1       2       3       4       5       6       7       8       9  Recall       0    Info    Vol+    Vol-     Ch+     Ch-      Up    Down    Left   Right      OK    Menu   Guide    List    Exit     Red   Green  Yellow    Blue   White Subtitle Teletext Audio      VF      AR   Sleep   Radio     Rec    Stop     Sat     M/*     Rew   Pause    Play    FFwd    Prev    Slow     Cut    Next     Fav SatDish
  RemoteKeyTP800ULx: array[0..52] of dword = (    39,    161,     42,     96,    150,     42,     96,    150,     42,     96,    150,     42,     96,    150,     38,     38,    152,    152,     93,     93,     59,    142,     98,     32,    169,     98,    169,     35,     78,    121,    164,     35,     79,    123,    166,     35,     79,     98,    166,     43,     84,    125,    166,     43,     84,    125,    166,     43,     84,    125,    166,     32,    122);
  RemoteKeyTP800ULy: array[0..52] of dword = (    19,     23,    122,    122,    122,    160,    160,    160,    197,    197,    197,    234,    234,    234,    452,    497,    452,    497,    322,    407,    358,    358,    362,    406,    323,    502,    406,    552,    552,    552,    552,    279,    279,    279,    279,     80,     80,    464,     80,    600,    600,    600,    600,    637,    637,    637,    637,    675,    675,    675,    675,    323,     80);
  RemoteKeyTP800LRx: array[0..52] of dword = (    79,    193,     85,    139,    193,     85,    139,    193,     85,    139,    193,     85,    139,    193,     84,     84,    198,    198,    142,    142,     93,    176,    137,     66,    203,    138,    203,     72,    115,    158,    201,     70,    114,    158,    201,     70,    114,    138,    201,     71,    112,    153,    194,     71,    112,    153,    194,     71,    112,    153,    194,     66,    157);
  RemoteKeyTP800LRy: array[0..52] of dword = (    59,     55,    150,    150,    150,    188,    188,    188,    225,    225,    225,    262,    262,    262,    496,    541,    496,    541,    356,    441,    405,    405,    401,    440,    357,    528,    440,    585,    585,    585,    585,    304,    304,    304,    304,    105,    105,    490,    105,    624,    624,    624,    624,    661,    661,    661,    661,    699,    699,    699,    699,    357,    105);

  RemoteKeyTMSULx : array[0..52] of dword =  (    32,    145,     21,     78,    138,     21,     78,    138,     21,     78,    138,     21,     78,    138,      8,      8,    145,    152,     71,     76,     53,    123,     84,     20,     65,    108,    152,     20,     65,    108,    152,     20,     65,    108,    152,     20,     65,    108,    152,     20,     65,    108,    152,     20,     65,    108,    152,     20,     65,    108,    152,      0,      0);
  RemoteKeyTMSULy : array[0..52] of dword =  (    37,     37,    139,    139,    139,    166,    166,    166,    192,    192,    192,    219,    219,    219,    258,    357,    262,    364,    272,    348,    294,    304,    307,    418,    418,    418,    418,    465,    465,    465,    465,    504,    504,    504,    504,    542,    542,    542,    542,    584,    584,    584,    584,    621,    621,    621,    621,    658,    658,    658,    658,      0,      0);
  RemoteKeyTMSLRx : array[0..52] of dword =  (    58,    170,     67,    127,    183,     67,    127,    183,     67,    127,    183,     67,    127,    183,     51,     52,    197,    198,    144,    133,     81,    154,    122,     54,     98,    141,    184,     54,     98,    141,    184,     54,     98,    141,    184,     54,     98,    141,    184,     54,     98,    141,    184,     54,     98,    141,    184,     54,     98,    141,    184,      0,      0);
  RemoteKeyTMSLRy : array[0..52] of dword =  (    63,     65,    158,    158,    158,    185,    185,    185,    212,    212,    212,    237,    237,    237,    302,    389,    301,    397,    304,    378,    348,    377,    347,    440,    440,    440,    440,    495,    495,    495,    495,    532,    532,    532,    532,    570,    570,    570,    570,    611,    611,    611,    611,    649,    649,    649,    649,    686,    686,    686,    686,      0,      0);

  RemoteKey5000ULx : array[0..52] of dword = (    64,    133,     51,    101,    151,     51,    101,    151,     51,    101,    151,     51,    101,    151,      0,      0,      0,      0,    100,    100,     39,    161,     95,     31,     59,    104,     59,     62,     93,    126,    157,    128,    180,    143,    180,      0,     46,    150,    143,    129,     86,     86,      0,     53,    163,    105,    157,     59,     52,      0,    155,     32,     99);
  RemoteKey5000ULy : array[0..52] of dword = (    31,     31,    108,    102,    108,    133,    133,    139,    169,    164,    170,    201,    195,    201,      0,      0,      0,      0,    257,    380,    318,    318,    314,    279,    250,    520,    398,    551,    553,    553,    551,    582,    361,    398,    279,      0,     74,     74,    250,    488,    488,    583,      0,    456,    484,    460,    456,    520,    484,      0,    520,    360,     69);
  RemoteKey5000LRx : array[0..52] of dword = (   104,    174,     87,    137,    187,     87,    137,    187,     87,    137,    187,     87,    137,    187,      0,      0,      0,      0,    138,    138,     77,    199,    143,     57,     95,    133,     95,     81,    112,    145,    176,    151,    206,    179,    206,      0,     87,    191,    179,    151,    109,    109,      0,     81,    186,    133,    185,     82,     74,      0,    178,     58,    140);
  RemoteKey5000LRy : array[0..52] of dword = (    54,     54,    131,    125,    131,    162,    156,    162,    192,    187,    194,    224,    218,    224,      0,      0,      0,      0,    296,    419,    357,    357,    362,    314,    277,    539,    425,    570,    572,    572,    570,    601,    396,    425,    396,      0,     97,     97,    277,    507,    507,    602,      0,    474,    503,    478,    474,    539,    503,      0,    539,    395,     92);

  RemoteKeyCodeTP800:array[0..52] of dword = ($1000a, $1000c, $10001, $10002, $10003, $10004, $10005, $10006, $10007, $10008, $10009, $1000b, $10000, $10014, $10047, $10048, $10045, $10046, $10012, $1001d, $1000f, $10015, $1001e, $1001c, $10016, $10042, $10017, $10023, $10024, $10025, $10026, $10049, $10021, $10037, $10013, $10044, $1000e, $10010, $10018, $1003d, $1003c, $10040, $10050, $10038, $1001a, $10039, $1003a, $10041, $1003b, $1003e, $10043, $10020, $10022);
  RemoteKeyCode    : array[0..52] of dword = ($1000a, $1000c, $10001, $10002, $10003, $10004, $10005, $10006, $10007, $10008, $10009, $1000b, $10000, $10014, $10047, $10048, $10045, $10046, $10012, $1001d, $1000f, $10015, $1001e, $1001c, $10016, $10042, $10017, $1003f, $10024, $10025, $10026, $10049, $10021, $10037, $10013, $10044, $1000e, $10010, $10018, $1003d, $1003c, $10040, $10022, $10038, $1001a, $10039, $1003a, $10041, $1003b, $1003e, $10043, $10020, $10022);
  RemoteKeyCode7100: array[0..52] of dword = ($1000a, $1000c, $10001, $10002, $10003, $10004, $10005, $10006, $10007, $10008, $10009, $1000b, $10000, $10014, $1003f, $10024, $10025, $10026, $10012, $1001d, $1000f, $10015, $1001e, $1001c, $10016, $10042, $10017, $10047, $10048, $10049, $1004a, $10049, $10021, $10037, $10013, $10045, $1000e, $10010, $10018, $1003d, $1003c, $10040, $10022, $10038, $1001a, $10039, $1003a, $10041, $1003b, $1003e, $10043, $10020, $10022);
  IRCode           : array[0..52] of dword = ( $50af,  $30cf,  $8877,  $48b7,  $c837,  $28d7,  $a857,  $6897,  $e817,  $18e7,  $9867,  $7887,  $08f7,  $b847,  $40bf,  $c03f,  $00ff,  $807f,  $00ff,  $807f,  $c03f,  $40bf,  $f807,  $58a7,  $d827,  $d02f,  $38c7,  $b24d,  $b04f,  $708f,  $f00f,  $32cd,  $e01f,  $e21d,  $a05f,      0,  $c23d,  $22dd,  $20df,  $d22d,  $52ad,  $7a85,      0,  $a25d,  $609f,  $629d,  $12ed,  $0af5,  $926d,      0,  $4ab5,  $906f,  $10ef);
                                             //                                                                                                                ?????   ?????                                                                                                                                                           ?????                                                   ?????                                                   ?????
type
  tPixelColor = record
    Blue               : byte;
    Green              : byte;
    Red                : byte;
    RLE                : Byte;
  end;

  tMacroBlock = record
    BlockIndex         : Integer;
    RLELength          : dword;
    RLEData            : array[0..255] of tPixelColor;
  end;

  pMacroBlock = ^tMacroBlock;

  tMacroBlockCache = record
    MacroBlock         : tMacroBlock;
    Updated            : Boolean;
  end;

  tCommands =
  (
    Cmd_Alive,
    Cmd_Authenticate,
    Cmd_RefreshAll,
    Cmd_KeyEvent,
    Cmd_HideOsd,
    Cmd_Reboot,
    Cmd_VideoFrame,
    Cmd_ASCIIEvent
  );

  tCmd_Alive = record
    cmd                : dword;
  end;

  tCmd_Authenticate = record
    cmd                : dword;
    CRC32              : dword;
  end;

  tCmd_RefreshAll = record
    cmd                : dword;
  end;

  tCmd_KeyEvent = record
    cmd                : dword;
    Key                : dword;
  end;

  tCmd_ASCIIEvent = record
    cmd                : dword;
    ASCIICode          : dword;
  end;

  tCmd_HideOsd = record
    cmd                : dword;
    HideOsd            : dword;
  end;

  tCmd_Reboot = record
    cmd                : dword;
  end;

  tCmd_VideoFrame = record
    cmd                : dword;
  end;

  tMessageIDs =
  (
    MID_RecordingDialog,
    MID_AuthFailed,
    MID_DirectOn,
    MID_DirectOff
  );

  tDisconnectReason =
  (
    DR_Normal,
    DR_Auth
  );

  TForm1 = class(TForm)
    WSocket_TMSRemote        : TWSocket;
    Button_Connect           : TButton;
    Label_IP                 : TLabel;
    Image_Remote_TMS         : TImage;
    MainMenu1                : TMainMenu;
    Menu_File                : TMenuItem;
    Menu_File_Sep1           : TMenuItem;
    Menu_File_Exit           : TMenuItem;
    ComboBox_Profile         : TComboBox;
    Panel_Image              : TPanel;
    Image1                   : TImage;
    CheckBox_HideOsd         : TCheckBox;
    SavePictureDialog1       : TSavePictureDialog;
    Menu_File_SaveScreen     : TMenuItem;
    Panel_NetworkRcv         : TPanel;
    Panel_NetworkXmt         : TPanel;
    Timer1                   : TTimer;
    Image_Remote_5000        : TImage;
    ComboBox_RemoteSelector  : TComboBox;
    Menu_TMS                 : TMenuItem;
    Menu_TMS_Reboot          : TMenuItem;
    ColorDialog1             : TColorDialog;
    Menu_File_Backgroundcolor: TMenuItem;
    Panel_NWInfo             : TPanel;
    XiProgressBar1           : TXiProgressBar;
    XiProgressBar2           : TXiProgressBar;
    IdIcmpClient1            : TIdIcmpClient;
    XiProgressBar3           : TXiProgressBar;
    XiProgressBar4           : TXiProgressBar;
    ScrollBar1               : TScrollBar;
    Image2                   : TImage;
    Menu_TMS_CaptureFrame    : TMenuItem;
    Menu_TMS_ClearFrame      : TMenuItem;
    Menu_TMS_Sep1            : TMenuItem;
    Menu_File_ConnectionProfiles: TMenuItem;
    TrayIcon1                : TTrayIcon;
    File_Menu_MinimizeToTray : TMenuItem;
    WSocket_TFIR             : TWSocket;
    Edit1                    : TMenuItem;
    Menu_Edit_PasteNumbers   : TMenuItem;
    Panel_DirectMode         : TPanel;
    Menu_Edit_PasteText      : TMenuItem;
    File_Menu_NewInstance    : TMenuItem;
    Image_Remote_TP800       : TImage;
    Image_KeyMask            : TImage;

    procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure WSocket_TMSRemoteDataAvailable(Sender: TObject; ErrCode: Word);
    procedure Button_ConnectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure WSocket_TMSRemoteSessionConnected(Sender: TObject; ErrCode: Word);
    procedure WSocket_TMSRemoteSessionClosed(Sender: TObject; ErrCode: Word);
    procedure Image_Remote_TP800MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Image_Remote_TP800MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Image_Remote_TMSMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Image_Remote_TMSMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure CheckBox_HideOsdClick(Sender: TObject);
    procedure Menu_File_SaveScreenClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Image_Remote_5000MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Image_Remote_5000MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ComboBox_RemoteSelectorChange(Sender: TObject);
    procedure Menu_TMS_RebootClick(Sender: TObject);
    procedure Menu_File_BackgroundcolorClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Menu_File_ExitClick(Sender: TObject);
    procedure Menu_TMS_CaptureFrameClick(Sender: TObject);
    procedure Menu_TMS_ClearFrameClick(Sender: TObject);
    procedure Menu_File_ConnectionProfilesClick(Sender: TObject);
    procedure UpdateConnectionProfileListbox();
    procedure ComboBox_ProfileChange(Sender: TObject);
    procedure TrayIcon1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure File_Menu_MinimizeToTrayClick(Sender: TObject);
    procedure WSocket_TMSRemoteBgException(Sender: TObject; E: Exception; var CanClose: Boolean);
    procedure WSocket_TMSRemoteError(Sender: TObject);
    procedure WMPowerBroadcast(var Msg: TMessage); message WM_POWERBROADCAST;
    procedure WSocket_TMSRemoteSendData(Sender: TObject; BytesSent: Integer);
    procedure WSocket_TMSRemoteSessionAvailable(Sender: TObject; ErrCode: Word);
    procedure WSocket_TMSRemoteSocksAuthState(Sender: TObject; AuthState: TSocksAuthState);
    procedure WSocket_TMSRemoteSocksConnected(Sender: TObject; ErrCode: Word);
    procedure WSocket_TMSRemoteSocksError(Sender: TObject; Error: Integer; Msg: string);
    procedure WSocket_TMSRemoteChangeState(Sender: TObject; OldState, NewState: TSocketState);
    procedure WSocket_TMSRemoteDataSent(Sender: TObject; ErrCode: Word);
    procedure WSocket_TMSRemoteDnsLookupDone(Sender: TObject; ErrCode: Word);
    procedure WSocket_TMSRemoteLineLimitExceeded(Sender: TObject; RcvdLength: Integer; var ClearData: Boolean);
    Function SocketStateString(State: tSocketState): String;
    procedure Menu_Edit_PasteNumbersClick(Sender: TObject);
    procedure Panel_DirectModeClick(Sender: TObject);
    procedure Menu_Edit_PasteTextClick(Sender: TObject);
    procedure File_Menu_NewInstanceClick(Sender: TObject);

  private
    var
      CommConnected          : Boolean;
      NWXmt                  : Int64;
      NWXmtHighlightTimeout  : dword;
      NWMessage              : Integer;
      DisconnectReason       : tDisconnectReason;
      AliveTimer             : dword;
      OfflineCaption         : String;

      NWRcv                  : Int64;
      NWRcvHighlightTimeout  : dword;
      NWRcvBuffer            : array of byte;
      NWRcvBufferSize        : dword;
      NWRcvBufferIn          : dword;
      NWRcvBufferOut         : dword;
      DoNotReenterDataAvail  : boolean;
      MacroBlockCache        : array[0..1619] of tMacroBlockCache;
      MacroBlockCacheVideo   : array[0..1619] of tMacroBlockCache;
      CachePtr               : dword;

      BGColor                : dword;
      VideoCaptured          : Boolean;
      Keymap                 : array[0..255] of dword;
      KeymapCtrl             : array[0..255] of dword;
      KeymapAltGr            : Array[0..255] of byte;
      DirectMode             : Boolean;
      AutoConnect            : Boolean;
      ScreenshotFormat       : String;
      KeyLongPressed         : Boolean;

    //Settings
    procedure LoadSettings();
    procedure SaveSettings();
    procedure LoadKeymap();

    function  TranslateRemotePixelToKey(x, y: dword): dword;
    function  TranslateRemotePixelToIRCode(x, y: dword): dword;
    procedure ImageShowText(s: String; Color: tColor);
    procedure ImageClear();
    procedure DrawBoundaryBoxes();
    procedure DrawMacroBlock(MacroBlock: pMacroBlock; Image: tImage);

    //Network
    procedure CommOpen();
    procedure CommClose();
//    function  PingServer(IP: String): Boolean;
    procedure XmtIndicator(NrBytes: Integer);
    procedure RcvIndicator(NrBytes: Integer);
    procedure SendAlive();
    procedure SendAuthentication();
    procedure SendKeyEvent(Key: dword);
    procedure SendASCIIEvent(ASCIICode: dword);
    procedure SendHideOsd(Hide: boolean);
    procedure SendReboot();
    procedure GetVideoFrame();
    procedure UpdateNWBufferInfo();
    procedure ProcessOSDMacroblock(MacroBlock: pMacroBlock);
    procedure ProcessVideoMacroblock(MacroBlock: pMacroBlock);
    procedure ProcessMessage(MacroBlock: pMacroBlock);
    procedure DrawOSD();
    procedure InvalidateOSD();
    procedure DrawVideo();
    procedure ClearVideo();
    procedure SendIRCode(IRCode: word);

  public
    var
      MultiInstance          : Boolean;

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{$REGION 'Settings'}
procedure TForm1.LoadSettings();

var
  Reg                  : tRegistry;
  i                    : Integer;
  HideOsd              : boolean;
  INI                  : tINIFile;

begin
  //Make sure that there is no combobox event triggered or there may be a save settings before all settings have been read
  if DoesINIProfileExist() then
  begin
    INI := tINIFile.Create(GetININame());

    HideOsd := INI.ReadBool('Window', 'HideOsd', FALSE);
    BGColor := INI.ReadInteger('Window', 'BGColor', 0);
    ScreenshotFormat := INI.ReadString('Window', 'ScreenshotFormat', '');

    //Is there any profile
    if not(ReadConnectionProfile(0, ConnectionProfile[0])) then
    begin
      if Form3 = nil then Application.CreateForm(TForm3, Form3);
      if Form3.ShowModal() = mrOk then SaveSettings();
      Form3.Free();
    end;

    //Read all connection profiles
    i := 0;
    while True do
    begin
      if not(ReadConnectionProfile(i, ConnectionProfile[i])) then break;
      inc(i);
    end;
    NrConnectionProfiles := i;

    if NrConnectionProfiles = 0 then
    begin
      MessageBox(Self.WindowHandle, 'At least one connection profile is necessary.'#13#10'Please restart TMSRemote and define a profile.', 'TMSRemote', MB_OK);
      halt(1);
    end;

    if INI.ValueExists('Window', 'CurrentConnectionProfile') then
      CurrentConnectionProfile := INI.ReadInteger('Window', 'CurrentConnectionProfile', 1) - 1
    else
      CurrentConnectionProfile := 0;

    File_Menu_MinimizeToTray.Checked := INI.ReadBool('Window', 'MinimizeToTray', false);

    INI.Free();
  end else
  begin
    Reg := tRegistry.Create();
    Reg.RootKey := HKEY_CURRENT_USER;

    Reg.OpenKey(ROOTKEY, true);

    HideOsd := false;
    if Reg.ValueExists('HideOsd') then
      HideOsd := Reg.ReadBool('HideOsd');

    if Reg.ValueExists('BGColor') then
      BGColor := Reg.ReadInteger('BGColor')
    else
      BGColor := 0;

    if Reg.ValueExists('ScreenshotFormat') then
      ScreenshotFormat := Reg.ReadString('ScreenshotFormat')
    else
      ScreenshotFormat := '';

    //Delete all old entries
    i := 0;
    while True do
    begin
      inc(i);
      if not(Reg.ValueExists(Format('IP%d', [i]))) then break;
      Reg.DeleteValue(Format('IP%d', [i]));
    end;
    if Reg.ValueExists('tcpPort') then Reg.DeleteValue('tcpPort');

    //Is there any profile
    if not(ReadConnectionProfile(0, ConnectionProfile[0])) then
    begin
      if Form3 = nil then Application.CreateForm(TForm3, Form3);
      if Form3.ShowModal() = mrOk then SaveSettings();
      Form3.Free();
    end;

    //Read all connection profiles
    i := 0;
    while True do
    begin
      if not(ReadConnectionProfile(i, ConnectionProfile[i])) then break;
      inc(i);
    end;
    NrConnectionProfiles := i;

    if NrConnectionProfiles = 0 then
    begin
      MessageBox(Self.WindowHandle, 'At least one connection profile is necessary.'#13#10'Please restart TMSRemote and define a profile.', 'TMSRemote', MB_OK);
      halt(1);
    end;

    if Reg.ValueExists('CurrentConnectionProfile') then
      CurrentConnectionProfile := Reg.ReadInteger('CurrentConnectionProfile') - 1
    else
      CurrentConnectionProfile := 0;

    if Reg.ValueExists('MinimizeToTray') then
      File_Menu_MinimizeToTray.Checked := Reg.ReadBool('MinimizeToTray');

    Reg.CloseKey();
    Reg.Free();
  end;

  UpdateConnectionProfileListbox();
  ComboBox_Profile.ItemIndex := CurrentConnectionProfile;
  ComboBox_RemoteSelector.ItemIndex := Profiles.ConnectionProfile[CurrentConnectionProfile].RemoteImageIndex;
  ComboBox_RemoteSelectorChange(nil);
  CheckBox_HideOsd.Checked := HideOsd;
end;

procedure TForm1.SaveSettings();

var
  Reg                  : tRegistry;
  INI                  : tINIFile;
  i                    : Integer;

begin
  //Write all connection profiles
  for i := 0 to NrConnectionProfiles - 1 do
    WriteConnectionProfile(i, ConnectionProfile[i]);

  if DoesINIProfileExist() then
  begin
    if (GetFileAttributes(pChar(GetININame())) and FILE_ATTRIBUTE_READONLY) = 0 then
    begin
      INI := tINIFile.Create(GetININame());
      INI.WriteBool('Window', 'HideOsd', CheckBox_HideOsd.Checked);
      INI.WriteInteger('Window', 'BGColor', BGColor);
      INI.WriteInteger('Window', 'CurrentConnectionProfile', CurrentConnectionProfile + 1);
      INI.WriteBool('Window', 'MinimizeToTray', File_Menu_MinimizeToTray.Checked);
      INI.WriteString('Window', 'ScreenshotFormat', ScreenshotFormat);
      INI.Free();
    end;
  end else
  begin
    Reg := tRegistry.Create();
    Reg.RootKey := HKEY_CURRENT_USER;

    Reg.OpenKey(ROOTKEY, true);
    Reg.WriteBool('HideOsd', CheckBox_HideOsd.Checked);
    Reg.WriteInteger('BGColor', BGColor);
    Reg.WriteString('ScreenshotFormat', ScreenshotFormat);
    Reg.WriteInteger('CurrentConnectionProfile', CurrentConnectionProfile + 1);
    Reg.WriteBool('MinimizeToTray', File_Menu_MinimizeToTray.Checked);
    Reg.CloseKey();
    Reg.Free();
  end;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  Image_Remote_TP800.Top := -ScrollBar1.Position;
  Image_Remote_TMS.Top := -ScrollBar1.Position;
  Image_Remote_5000.Top := -ScrollBar1.Position;
end;

procedure TForm1.LoadKeymap();

var
  INIFileName          : String;
  INI                  : tINIFile;
  AppDir, s            : String;
  Keys                 : tStringList;
  i                    : Integer;
  Key                  : Integer;

begin
  AppDir := IncludeTrailingBackslash(ExtractFilePath(paramstr(0)));

  Keys := tStringList.Create();

  if ComboBox_RemoteSelector.ItemIndex = -1 then
  begin
    INIFileName := 'TMSRemote.ini';
  end else
  begin
    INIFileName := Format('TMSRemote_%s.ini', [ComboBox_RemoteSelector.Items[ComboBox_RemoteSelector.ItemIndex]]);
    if not(FileExists(AppDir + INIFileName)) then INIFileName := 'TMSRemote.ini';
  end;

  INI := tINIFile.Create(AppDir + INIFileName);

  INI.ReadSection('Keymap', Keys);
  zeromemory(@Keymap[0], sizeof(Keymap));
  for i := 0 to Keys.Count - 1 do
  begin
    Key:= StrToInt('$' + Keys.Strings[i]);
    Keymap[Key] := StrToInt('$' + INI.ReadString('Keymap', Keys.Strings[i], '0'));
  end;

  INI.ReadSection('KeymapCtrl', Keys);
  zeromemory(@KeymapCtrl[0], sizeof(KeymapCtrl));
  for i := 0 to Keys.Count - 1 do
  begin
    Key:= StrToInt('$' + Keys.Strings[i]);
    KeymapCtrl[Key] := StrToInt('$' + INI.ReadString('KeymapCtrl', Keys.Strings[i], '0'));
  end;

  INI.ReadSection('AltGr', Keys);
  zeromemory(@KeymapAltGr[0], sizeof(KeymapAltGr));
  for i := 0 to Keys.Count - 1 do
  begin
    Key:= StrToInt('$' + Keys.Strings[i]);
    s := INI.ReadString('AltGr', Keys.Strings[i], '');
    KeymapAltGr[Key] := ord(s[1]);
  end;

  INI.Free();
  Keys.Free();
end;
{$ENDREGION}

{$REGION 'GUI'}
procedure TForm1.FormCreate(Sender: TObject);

var
  hSemaphore             : dword;
  hWnd                   : dword;
  i                      : Integer;
  NewInstance            : Boolean;
  ProfileParameter       : String;
  RemoteParameter        : String;

begin
  OfflineCaption := 'TMS Remote - V' + CyTools.GetProductVersion(paramstr(0));;
  MultiInstance := false;

  NewInstance := false;
  ProfileParameter := '';
  RemoteParameter := '';
  AutoConnect := False;

  for i := 1 to ParamCount do
  begin
    if LowerCase(Copy(ParamStr(i), 1, 12)) = '/newinstance' then NewInstance := true;
    if LowerCase(Copy(ParamStr(i), 1, 9)) = '/profile=' then ProfileParameter := LowerCase(Copy(ParamStr(i), 10));
    if LowerCase(Copy(ParamStr(i), 1, 8)) = '/remote=' then RemoteParameter := LowerCase(Copy(ParamStr(i), 9));
    if LowerCase(Copy(ParamStr(i), 1, 12)) = '/autoconnect' then AutoConnect := True;
  end;

  if NewInstance then
  begin
    MultiInstance := true;
    OfflineCaption := OfflineCaption + ' (TFIR support disabled)';
  end else
  begin
    Form1.Caption := 'temp delete';
    hSemaphore := CreateSemaphore(nil, 1, 1, 'TMSRemoteSemaphore');
    if hSemaphore = 0 then halt(1);
    if WaitForSingleObject(hSemaphore, 100) <> WAIT_OBJECT_0 then
    begin
      CloseHandle(hSemaphore);
      hWnd := FindWindow(nil, pChar(OfflineCaption));
      if hWnd <> 0 then ForceForegroundWindow(hWnd);
      halt(2);
    end;
  end;

  Form1.Caption := OfflineCaption;
  Form1.Top := 0;
  Image2.Width := 720;
  Image2.Height := 576;
  VideoCaptured := false;
  CommConnected := false;
  DisconnectReason := DR_Normal;
  ComboBox_RemoteSelector.Items.Add('TMS');
  ComboBox_RemoteSelector.Items.Add('TF5000');
  ComboBox_RemoteSelector.Items.Add('TF7100HD');
  ComboBox_RemoteSelector.Items.Add('SRP2401Eco');

  NWRcvBufferSize := DEFAULTBUFFERSIZE;
  SetLength(NWRcvBuffer, NWRcvBufferSize);
  NWRcvBufferIn := 0;
  NWRcvBufferOut := 0;
  DoNotReenterDataAvail := false;
  NWMessage := -1;

  LoadSettings();
  LoadKeymap();
  ClearVideo();

  TrayIcon1.Icon := Form1.Icon;
  TrayIcon1.Hint := 'TMSRemote';
  TrayIcon1.Visible := true;

  ImageShowText('Disconnected', rgb(255,0,0));
  DirectMode := false;
  Application.OnMessage := AppMessage;

  if ProfileParameter <> '' then
  begin
    for i := 0 to ComboBox_Profile.Items.Count - 1 do
      if LowerCase(ComboBox_Profile.Items[i]) = ProfileParameter then
      begin
        ComboBox_Profile.ItemIndex := i;
        ComboBox_ProfileChange(Self);
        break;
      end;
  end;

  if RemoteParameter <> '' then
  begin
    for i := 0 to ComboBox_RemoteSelector.Items.Count - 1 do
      if LowerCase(ComboBox_RemoteSelector.Items[i]) = RemoteParameter then
      begin
        ComboBox_RemoteSelector.ItemIndex := i;
        ComboBox_RemoteSelectorChange(Self);
        break;
      end;
  end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  if File_Menu_MinimizeToTray.Checked and (Form1.WindowState = wsMinimized) then
    Form1.Hide();
end;

procedure TForm1.AppMessage(var Msg: TMsg; var Handled: Boolean);

var
  CTRL                 : Boolean;
  Code                 : dword;
  Key                  : byte;
  KeyState             : tKeyboardState;

begin
  if (Msg.message <> WM_KEYDOWN) and (Msg.message <> WM_KEYUP) and (Msg.message <> WM_CHAR) then
    Exit;

  if (not CommConnected) then
    Exit;

//  if (Msg.message <> WM_MOUSEMOVE) and (Msg.message <> WM_TIMER) then
//    OutputDebugString(pchar(format('AppMessage: Msg=%8.8x, wparam=%8.8x, lparam=%8.8x, CTRL=%d', [Msg.message, Msg.wParam, Msg.lParam, BoolToInt(CTRL)])));

  CTRL := (GetKeyState(VK_CONTROL) < 0);

  if (CTRL or not DirectMode) and ((Msg.message = WM_KEYDOWN) or (Msg.message = WM_KEYUP)) then
  begin
    //Send out the key
    GetKeyboardState(KeyState);
    Key := Msg.WParam;
    if (KeyState[VK_CONTROL] >= $80) and (Char(Key) = 'V') then
    begin
      //Special case STRG-V
      if (Msg.message = WM_KEYDOWN) then
        Menu_Edit_PasteNumbersClick(nil);
    end
    else if DirectMode and (KeyState[VK_MENU] >= $80) then
    begin
      //AltGr keys as defined in TMSRemote.ini [AltGr]
      if (Msg.message = WM_KEYDOWN) and (Key < $100) and (KeymapAltGr[Key] <> 0) then
        SendASCIIEvent(KeymapAltGr[Key]);
    end
    else if (KeyState[VK_CONTROL] >= $80) then
    begin
      //Ctrl keys as defined in TMSRemote.ini [KeymapCtrl]
      //Ignore the Ctrl key
      if (Key < $100) and (KeymapCtrl[Key] <> 0) then
      begin
        if (Msg.message = WM_KEYDOWN) then
        begin
          if (Msg.lParam shr 30 = 1) and not KeyLongPressed then
          begin
            SendKeyEvent(KeymapCtrl[Key] or $01000000);
            KeyLongPressed := true;
          end;
          SendKeyEvent(KeymapCtrl[Key]);
        end
        else if (Msg.message = WM_KEYUP) then
        begin
          SendKeyEvent(KeymapCtrl[Key] or $02000000);
          KeyLongPressed := false;
        end;
      end;
    end
    else begin
      //Standard keys as defined in TMSRemote.ini [Keymap]
      if (Key < $100) and (Keymap[Key] <> 0) then
      begin
        if (Msg.message = WM_KEYDOWN) then
        begin
          if (Msg.lParam shr 30 = 1) and not KeyLongPressed then
          begin
            SendKeyEvent(Keymap[Key] or $01000000);
            KeyLongPressed := true;
          end;
          SendKeyEvent(Keymap[Key]);
        end
        else if (Msg.message = WM_KEYUP) then
        begin
          SendKeyEvent(Keymap[Key] or $02000000);
          KeyLongPressed := false;
        end;
      end;
    end;
    Handled := true;
  end

  else if (DirectMode and not(CTRL)) and ((Msg.message = WM_KEYDOWN) or (Msg.message = WM_CHAR)) then
  begin
//    OutputDebugString(pchar(format('AppMessage: Msg=%8.8x, wparam=%8.8x, lparam=%8.8x, CTRL=%d', [Msg.message, Msg.wParam, Msg.lParam, BoolToInt(CTRL)])));

    //Send out the ASCII Code
    Code := Msg.wParam;
    Handled := true;

    if Msg.message = WM_KEYDOWN then
    begin
      case Msg.wParam of
        $2d: Code := $012d;   //Ins
        $2e: Code := $007F;   //Del

        $24: Code := $0124;   //Pos1
        $23: Code := $0123;   //End
        $22: Code := $0122;   //PageDown
        $21: Code := $0121;   //PageUp
        $25: Code := $0125;   //Left
        $26: Code := $0126;   //Up
        $27: Code := $0127;   //Right
        $28: Code := $0128;   //Down

        $09: Code := $0009;   //Tab

        $70: Code := $0170;   //F1
        $71: Code := $0171;   //F2
        $72: Code := $0172;   //F3
        $73: Code := $0173;   //F4
        $74: Code := $0174;   //F5
        $75: Code := $0175;   //F6
        $76: Code := $0176;   //F7
        $77: Code := $0177;   //F8
        $78: Code := $0178;   //F9
        $79: Code := $0179;   //F10 - altough that won't work because F10 is used by Windows to activate the menu of an application
        $7a: Code := $017a;   //F11
        $7b: Code := $017b;   //F12
        else
        begin
          Code := 0;
          Handled := false;
        end;
      end;
    end;

//    OutputDebugString(pchar(Format('AppMessage: Code=%4.4x-%2.2x', [Msg.message, Code])));
    if (Code <> 0) then SendASCIIEvent(Code);
  end;
end;

procedure TForm1.WMPowerBroadcast(var Msg: TMessage);
begin
  //OutputDebugString(pchar(format('WMPowerBroadcast: Msg=%8.8x, wparam=%8.8x, lparam=%8.8x', [Msg.Msg, Msg.WParam, Msg.LParam])));

  if (Msg.WParam = PBT_APMQUERYSUSPEND) or (Msg.WParam = PBT_APMQUERYSTANDBY) then
  begin
    if CommConnected then
    begin
      CommClose();
      ClearVideo();
    end;
    Msg.Result := -1;
  end;
end;

procedure TForm1.File_Menu_MinimizeToTrayClick(Sender: TObject);
begin
  File_Menu_MinimizeToTray.Checked := not(File_Menu_MinimizeToTray.Checked);
end;

procedure TForm1.File_Menu_NewInstanceClick(Sender: TObject);

var
  TMSRemoteEXE          : String;
  RC                    : dword;
  ProcessInfo           : tProcessInformation;

begin
  TMSRemoteEXE := Paramstr(0);
  CyTools.ExecuteFileAndWait(TMSRemoteEXE, '/NewInstance', ExtractFilePath(TMSRemoteEXE), 1, false, RC, ProcessInfo);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  WSocket_TMSRemote.Close;
  TrayIcon1.Visible := false;
end;

procedure TForm1.DrawBoundaryBoxes();

var
  x, y                 : Integer;
  Image                : ^tImage;

begin
  case ComboBox_RemoteSelector.ItemIndex of
    0: Image := @Image_Remote_TMS;
    1: Image := @Image_Remote_5000;
    2: Image := @Image_Remote_TMS;
    3: Image := @Image_Remote_TP800;
    else Image := @Image_Remote_TMS;
  end;

  for y := 0 to Image.Height - 1 do
    for x := 0 to Image.Width - 1 do
      if TranslateRemotePixelToKey(x, y) <> 0 then
        Image_KeyMask.Canvas.Pixels[x, y] := $00ff0000;
end;

procedure TForm1.Button_ConnectClick(Sender: TObject);

var
  ret                  : Integer;

begin
  Button_Connect.Enabled := false;
  if CommConnected then
  begin
    CommClose();
    ClearVideo();
    Form1.Caption := OfflineCaption;
    TrayIcon1.Hint := 'TMSRemote';
  end else
  begin
    CommClose();
    SaveSettings();
    ImageShowText(format('Trying to connect to ''%s''', [ComboBox_Profile.Items[ComboBox_Profile.ItemIndex]]), 0);
    Form2.SetMultiInstance(MultiInstance);
    ret := Form2.ShowModal();
    if ret = mrOk then
    begin
      Panel_Image.SetFocus();
      CommOpen();
      Form1.Caption := ComboBox_Profile.Items[ComboBox_Profile.ItemIndex] + ' - TMS Remote';
      TrayIcon1.Hint := ComboBox_Profile.Items[ComboBox_Profile.ItemIndex];
    end else
    begin
      WSocket_TMSRemoteSessionClosed(nil, 0);
    end;
  end;
end;

procedure TForm1.CheckBox_HideOsdClick(Sender: TObject);
begin
  SendHideOsd(CheckBox_HideOsd.Checked);
  SaveSettings();
end;

procedure TForm1.ComboBox_ProfileChange(Sender: TObject);
begin
  CurrentConnectionProfile := ComboBox_Profile.ItemIndex;
  ComboBox_RemoteSelector.ItemIndex := Profiles.ConnectionProfile[CurrentConnectionProfile].RemoteImageIndex;
  ComboBox_RemoteSelectorChange(nil);
end;

procedure TForm1.ComboBox_RemoteSelectorChange(Sender: TObject);

var
  i                    : Integer;

begin
  Profiles.ConnectionProfile[CurrentConnectionProfile].RemoteImageIndex := ComboBox_RemoteSelector.ItemIndex;
  SaveSettings();

  for i := 0 to ComboBox_RemoteSelector.Items.Count - 1 do
  begin
    case i of
      0: Image_Remote_TMS.Visible := (ComboBox_RemoteSelector.ItemIndex = 0) or
                                     (ComboBox_RemoteSelector.ItemIndex = 2);
      1: Image_Remote_5000.Visible := ComboBox_RemoteSelector.ItemIndex = 1;
      2: ;
      3: Image_Remote_TP800.Visible := ComboBox_RemoteSelector.ItemIndex = 3;
    end;
  end;
  LoadKeymap();
end;

procedure TForm1.Image_Remote_TMSMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

var
  Key                  : dword;

begin
//  if Shift = [ssAlt, ssLeft] then
//  begin
//    DrawBoundaryBoxes();
//    exit();
//  end;

  Key := TranslateRemotePixelToKey(x, y);
  if Key <> 0 then
  begin
    if Shift = [ssCtrl, ssLeft] then
    begin
      Key := TranslateRemotePixelToIRCode(x, y);
      if Key <> 0 then SendIRCode(Key);
    end else
    begin
      if Shift = [ssShift, ssLeft] then
        SendKeyEvent(Key or $10000000)
      else
        SendKeyEvent(Key);
    end;
  end;
end;

procedure TForm1.Image_Remote_TMSMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

var
  Key                  : dword;

begin
  if Shift <> [ssCtrl] then
  begin
    Key := TranslateRemotePixelToKey(x, y);
    if Key <> 0 then SendKeyEvent(Key or $02000000);
  end;
end;

procedure TForm1.Image_Remote_TP800MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

var
  Key                  : dword;

begin
  Key := TranslateRemotePixelToKey(x, y);
  if Key <> 0 then
  begin
    if Shift = [ssCtrl, ssLeft] then
    begin
      Key := TranslateRemotePixelToIRCode(x, y);
      if Key <> 0 then SendIRCode(Key);
    end else
    begin
      if Shift = [ssShift, ssLeft] then
        SendKeyEvent(Key or $10000000)
      else
        SendKeyEvent(Key);
    end;
  end;
end;

procedure TForm1.Image_Remote_TP800MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

var
  Key                  : dword;

begin
  if Shift <> [ssCtrl] then
  begin
    Key := TranslateRemotePixelToKey(x, y);
    if Key <> 0 then SendKeyEvent(Key or $02000000);
  end;
end;

procedure TForm1.Image_Remote_5000MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

var
  Key                  : dword;

begin
  Key := TranslateRemotePixelToKey(x, y);
  if Key <> 0 then
  begin
    if Shift = [ssCtrl, ssLeft] then
    begin
      Key := TranslateRemotePixelToIRCode(x, y);
      if Key <> 0 then SendIRCode(Key);
    end else
    begin
      if Shift = [ssShift, ssLeft] then
        SendKeyEvent(Key or $10000000)
      else
        SendKeyEvent(Key);
    end;
  end;
end;

procedure TForm1.Image_Remote_5000MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

var
  Key                  : dword;

begin
  if Shift <> [ssCtrl] then
  begin
    Key := TranslateRemotePixelToKey(x, y);
    if Key <> 0 then SendKeyEvent(Key or $02000000);
  end;
end;

procedure TForm1.ImageClear();

var
  Rect                 : tRect;

begin
  Rect.TopLeft := Point(0, 0);
  Rect.BottomRight := Point(720, 576);
  Image1.Canvas.Brush.Color := clBtnFace;
  Image1.Canvas.FillRect(Rect);
end;

procedure TForm1.ImageShowText(s: String; Color: tColor);
begin
  ImageClear();
  Image1.Canvas.Font.Color := Color;
  Image1.Canvas.Font.Name  := 'Calibri';
  Image1.Canvas.Font.Size  := 24;
  Image1.Canvas.TextOut((720 - Image1.Canvas.TextWidth(s)) shr 1, Image1.Height shr 1, s);
  Image1.Refresh();
end;

procedure TForm1.Timer1Timer(Sender: TObject);

var
  t                    : dword;

begin
  t := GetTickCount();
  if (Panel_NetworkRcv.Color <> clBtnFace) and (t > NWRcvHighlightTimeout) then
    Panel_NetworkRcv.Color := clBtnFace;

  if (Panel_NetworkXmt.Color <> clBtnFace) and (t > NWXmtHighlightTimeout) then
    Panel_NetworkXmt.Color := clBtnFace;

  SendAlive();

  if AutoConnect then
  begin
    AutoConnect := False;
    Button_ConnectClick(Self);
  end;
end;

procedure TForm1.Menu_Edit_PasteNumbersClick(Sender: TObject);

var
  s                    : String;
  i                    : Integer;

begin
  s := Clipboard.AsText;

  //Just leave the numbers
  i := 1;
  while i <= Length(s) do
  begin
    if (s[i] < '0') or (s[i] > '9') then
      Delete(s, i, 1)
    else
      inc(i);
  end;

  for i := 1 to Length(s) do
  begin
    SendKeyEvent((ord(s[i]) - $30) or $10000);
    Application.HandleMessage();
    Sleep(100);
    Application.HandleMessage();
  end;
end;

procedure TForm1.Menu_Edit_PasteTextClick(Sender: TObject);

var
  s                    : String;
  i                    : Integer;

begin
  s := Clipboard.AsText;
  for i := 1 to Length(s) do
  begin
    SendASCIIEvent(ord(s[i]));
    Application.HandleMessage();
    Sleep(50);
    Application.HandleMessage();
  end;
end;

procedure TForm1.Menu_File_BackgroundcolorClick(Sender: TObject);
begin
  ColorDialog1.Color := BGColor;
  if ColorDialog1.Execute() then
  begin
    BGColor := ColorDialog1.Color;
    SaveSettings();
    if not(VideoCaptured) then
    begin
      ClearVideo();
      InvalidateOSD();
    end;
  end;
end;

procedure TForm1.Menu_File_ExitClick(Sender: TObject);
begin
  Self.Close();
end;

procedure TForm1.Menu_File_SaveScreenClick(Sender: TObject);

var
  jpg                  : tJPEGImage;
  png                  : TPNGObject;
  FileName, Ext        : String;
  i                    : integer;
  SeparatorChar        : Array[0..0] of Char;
  FilterList           : tArray<string>;

begin
  SavePictureDialog1.Filter := 'JPEG (*.jpg)|*.jpg|Bitmap (*.bmp)|*.bmp|PNG (*.png)|*.png|All files|*.*';

  if ScreenshotFormat <> '' then
  begin
    SavePictureDialog1.DefaultExt := ScreenshotFormat;

    //Adapt FilterIndex to the last file extension
    SeparatorChar[0] := '|';
    FilterList := SavePictureDialog1.Filter.Split(SeparatorChar);
    for i := 0 to High(FilterList) do
      if pos(ScreenshotFormat, FilterList[i]) > 0 then
      begin
        SavePictureDialog1.FilterIndex := (i shr 1) + 1;
        break;
      end;
  end else
  begin
    SavePictureDialog1.DefaultExt := '.jpg';
    SavePictureDialog1.FilterIndex := 1;
  end;

  //Display the dialog
  if SavePictureDialog1.Execute then
  begin
    FileName := SavePictureDialog1.FileName;

    //If there's still no file name extension, make sure to add one according to the dialog's filter settings
    if ExtractFileExt(FileName) = '' then
      case SavePictureDialog1.FilterIndex of
        1: FileName := ChangeFileExt(FileName, '.jpg');
        2: FileName := ChangeFileExt(FileName, '.bmp');
        3: FileName := ChangeFileExt(FileName, '.png');
      end;

    Ext := LowerCase(ExtractFileExt(FileName));
    ScreenshotFormat := Ext;
    SaveSettings();

    if Ext = '.bmp' then
      Image1.Picture.SaveToFile(FileName);

    if Ext = '.jpg' then
    begin
      jpg := tJPEGImage.Create();
      jpg.Performance := jpBestQuality;
      jpg.Assign(Image1.Picture.Bitmap);
      jpg.SaveToFile(FileName);
      jpg.Free();
    end;

    if Ext = '.png' then
    begin
      png := TPNGObject.Create;
      png.Assign(Image1.Picture.Bitmap);
      png.SaveToFile(FileName);
      png.Free;
    end;
  end;
end;

procedure TForm1.Menu_File_ConnectionProfilesClick(Sender: TObject);
begin
  Form3.ShowModal();
  SaveSettings();
  UpdateConnectionProfileListbox();
end;

procedure TForm1.Menu_TMS_CaptureFrameClick(Sender: TObject);
begin
  GetVideoFrame();
end;

procedure TForm1.Menu_TMS_ClearFrameClick(Sender: TObject);
begin
  ClearVideo();
  InvalidateOSD();
end;

procedure TForm1.Menu_TMS_RebootClick(Sender: TObject);
begin
  if MessageBox(Self.WindowHandle, 'Do you really want to reboot your Toppy?', 'TMSRemote', MB_YESNO or MB_ICONQUESTION) = mrYes then
    SendReboot();
end;

procedure TForm1.UpdateConnectionProfileListbox();

var
  i, j                 : Integer;

begin
  j := ComboBox_Profile.ItemIndex;
  ComboBox_Profile.Items.Clear();
  for i := 0 to NrConnectionProfiles - 1 do
    ComboBox_Profile.Items.Add(ConnectionProfile[i].ProfileName);
  ComboBox_Profile.ItemIndex := j;
end;

procedure TForm1.DrawMacroBlock(MacroBlock: pMacroBlock; Image: tImage);

var
  x0, y0               : integer;
  p, n, RL, RLCnt      : Integer;
  c                    : dword;
  PixelCount           : Integer;
  Rect                 : tRect;
  RLEData              : ^tPixelColor;

begin
  y0 := (MacroBlock.BlockIndex div 45) shl 4;
  x0 := (MacroBlock.BlockIndex mod 45) shl 4;
  p := 0;
  for n := 0 to MacroBlock.RLELength - 1 do
  begin
    RLEData := @MacroBlock.RLEData[n];
    RL := RLEData.RLE;
    c := RGB(RLEData.Red, RLEData.Green, RLEData.Blue);

    //Some optimization
    if RL = 255 then
    begin
      Rect.TopLeft     := Point(x0, y0);
      Rect.BottomRight := Point(x0 + 16, y0 + 16);
      with Image.Canvas do
      begin
        if c = 0 then
          Image1.Canvas.CopyRect(Rect, Image2.Canvas, Rect)
        else begin
          Brush.Color := c;
          FillRect(Rect);
        end;
      end;
      inc(p, 256);
    end else
    begin
      RLCnt := 0;
      repeat
        PixelCount := 16 - (p and 15);
        if (PixelCount > 1) and ((RL - RLCnt) >= PixelCount) then
        begin
          with Image.Canvas do
          begin
            if c = 0 then
            begin
              Rect.TopLeft     := Point(x0 + (p and 15), y0 + (p shr 4));
              Rect.BottomRight := Point(x0 + 16        , y0 + (p shr 4));
              Image1.Canvas.CopyRect(Rect, Image2.Canvas, Rect);
            end else
            begin
              Pen.Color := c;
              MoveTo(x0 + (p and 15), y0 + (p shr 4));
              LineTo(x0 + 16, y0 + (p shr 4));
            end;
          end;
          inc(p, PixelCount);
          inc(RLCnt, PixelCount);
        end else
        begin
          if c = 0 then
            Image.Canvas.Pixels[x0 + (p and 15), y0 + (p shr 4)] := Image2.Canvas.Pixels[x0 + (p and 15), y0 + (p shr 4)]
          else
            Image.Canvas.Pixels[x0 + (p and 15), y0 + (p shr 4)] := c;
          inc(p);
          inc(RLCnt);
        end;
      until RLCnt > RL;
    end;
  end;
end;
{$ENDREGION}

function TForm1.TranslateRemotePixelToKey(x, y: dword): dword;

var
  i                    : Integer;

begin
  Result := 0;

  case ComboBox_RemoteSelector.ItemIndex of
    0: begin
      //TMS
      for i := 0 to high(RemoteKeyTMSULx) do
        if (x >= RemoteKeyTMSULx[i]) and
           (x <= RemoteKeyTMSLRx[i]) and
           (y >= RemoteKeyTMSULy[i]) and
           (y <= RemoteKeyTMSLRy[i]) then
        begin
          Result := RemoteKeyCode[i];
          exit;
        end;
      end;

    1: begin
      //TF5000
        for i := 0 to high(RemoteKey5000ULx) do
        if (x >= RemoteKey5000ULx[i]) and
           (x <= RemoteKey5000LRx[i]) and
           (y >= RemoteKey5000ULy[i]) and
           (y <= RemoteKey5000LRy[i]) then
        begin
          Result := RemoteKeyCode[i];
          exit;
        end;
    end;

    2: begin
      //TMS with TF7100HD key codes
      for i := 0 to high(RemoteKeyTMSULx) do
        if (x >= RemoteKeyTMSULx[i]) and
           (x <= RemoteKeyTMSLRx[i]) and
           (y >= RemoteKeyTMSULy[i]) and
           (y <= RemoteKeyTMSLRy[i]) then
        begin
          Result := RemoteKeyCode7100[i];
          exit;
        end;
    end;

    3: begin
      //SRP-2401 Eco
      for i := 0 to high(RemoteKeyTP800ULx) do
        if (x >= RemoteKeyTP800ULx[i]) and
           (x <= RemoteKeyTP800LRx[i]) and
           (y >= RemoteKeyTP800ULy[i]) and
           (y <= RemoteKeyTP800LRy[i]) then
        begin
          Result := RemoteKeyCodeTP800[i];
          exit;
        end;
      end;
  end;
end;

function TForm1.TranslateRemotePixelToIRCode(x, y: dword): dword;

var
  i                    : Integer;

begin
  Result := 0;

  case ComboBox_RemoteSelector.ItemIndex of
    0: begin
      //TMS
      for i := 0 to high(RemoteKeyTMSULx) do
        if (x >= RemoteKeyTMSULx[i]) and
           (x <= RemoteKeyTMSLRx[i]) and
           (y >= RemoteKeyTMSULy[i]) and
           (y <= RemoteKeyTMSLRy[i]) then
        begin
          Result := IRCode[i];
          exit;
        end;
      end;

    1: begin
      //TF5000
        for i := 0 to high(RemoteKey5000ULx) do
        if (x >= RemoteKey5000ULx[i]) and
           (x <= RemoteKey5000LRx[i]) and
           (y >= RemoteKey5000ULy[i]) and
           (y <= RemoteKey5000LRy[i]) then
        begin
          Result := IRCode[i];
          exit;
        end;
    end;

    2: begin
      //TMS with TF7100HD key codes
      for i := 0 to high(RemoteKeyTMSULx) do
        if (x >= RemoteKeyTMSULx[i]) and
           (x <= RemoteKeyTMSLRx[i]) and
           (y >= RemoteKeyTMSULy[i]) and
           (y <= RemoteKeyTMSLRy[i]) then
        begin
          Result := IRCode[i];
          exit;
        end;
    end;

    3: begin
      //SRP-2401 Eco
      for i := 0 to high(RemoteKeyTP800ULx) do
        if (x >= RemoteKeyTP800ULx[i]) and
           (x <= RemoteKeyTP800LRx[i]) and
           (y >= RemoteKeyTP800ULy[i]) and
           (y <= RemoteKeyTP800LRy[i]) then
        begin
          Result := IRCode[i];
          exit;
        end;
      end;
  end;
end;

procedure TForm1.TrayIcon1Click(Sender: TObject);
begin
  Form1.WindowState := wsNormal;
  Form1.Show;
  SetWindowPos(Form1.Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);
  Application.ProcessMessages;
  SetWindowPos(Form1.Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);
end;

{$REGION 'Network'}
procedure TForm1.CommOpen();

var
  CP                   : ^tConnectionProfile;

begin
//  OutputDebugString('CommOpen');

  NWMessage := -1;

  CP := @ConnectionProfile[CurrentConnectionProfile];

  WSocket_TMSRemote.Addr := CP.ToppyIP;
  WSocket_TMSRemote.Port := format('%d', [CP.ToppyPort]);
  WSocket_TMSRemote.Proto := 'tcp';

  try
    WSocket_TMSRemote.Connect;

  except

  end;

  if CP.TFIRInUse and not(MultiInstance) then
  begin
    WSocket_TFIR.Addr := CP.TFIRIP;
    WSocket_TFIR.Port := format('%d', [CP.TFIRPort]);
    WSocket_TFIR.LocalPort := WSocket_TFIR.Port;
    WSocket_TFIR.Proto := 'udp';
    WSocket_TFIR.Connect();
  end;
end;

procedure TForm1.CommClose();
begin
//  OutputDebugString('CommClose');
  WSocket_TMSRemote.Close();
  WSocket_TFIR.Close();
end;

procedure TForm1.XmtIndicator(NrBytes: Integer);
begin
  if NrBytes > 0 then
  begin
    inc(NWXmt, NrBytes);
    Panel_NetworkXmt.Caption := format('Xmt=%s', [cytools.FileSizeString(NWXmt)]);
    NWXmtHighlightTimeout := GetTickCount() + 200;
    if Panel_NetworkXmt.Color <> rgb(255,0,0) then
    begin
      Panel_NetworkXmt.Color := rgb(255,0,0);

    end;
    Panel_NetworkXmt.Refresh();
  end;
end;

procedure TForm1.RcvIndicator(NrBytes: Integer);
begin
  if NrBytes > 0 then
  begin
    inc(NWRcv, NrBytes);
    Panel_NetworkRcv.Caption := format('Rcv=%s', [cytools.FileSizeString(NWRcv)]);
    NWRcvHighlightTimeout := GetTickCount() + 200;
    if Panel_NetworkRcv.Color <> rgb(0,255,0) then
    begin
      Panel_NetworkRcv.Color := rgb(0,255,0);

    end;
    Panel_NetworkRcv.Refresh();
  end;
end;

procedure TForm1.SendAlive();

var
  Cmd                  : tCmd_Alive;

begin
  if CommConnected and (GetTickCount() > AliveTimer)then
  begin
    AliveTimer := GetTickCount() + 1000;

    //Do not use XmtIndicator() as it will blink all the time
    inc(NWXmt, sizeof(tCmd_Alive));
    Cmd.cmd := ord(Cmd_Alive);
    WSocket_TMSRemote.Send(@Cmd, sizeof(tCmd_Alive));
  end;
end;

procedure TForm1.SendAuthentication();

var
  Cmd                  : tCmd_Authenticate;
  CP                   : ^tConnectionProfile;

begin
  CP := @ConnectionProfile[CurrentConnectionProfile];
  if CommConnected then
  begin
    XmtIndicator(sizeof(tCmd_Authenticate));
    Cmd.cmd := ord(Cmd_Authenticate);
    Cmd.CRC32 := CP.PwdHash;
    WSocket_TMSRemote.Send(@Cmd, sizeof(tCmd_Authenticate));
  end;
end;

procedure TForm1.SendKeyEvent(Key: dword);

var
  Cmd                  : tCmd_KeyEvent;

begin
  if CommConnected then
  begin
    XmtIndicator(sizeof(tCmd_KeyEvent));
    Cmd.cmd := ord(Cmd_KeyEvent);
    Cmd.Key := Key;
    WSocket_TMSRemote.Send(@Cmd, sizeof(tCmd_KeyEvent));
  end;
end;

procedure TForm1.SendASCIIEvent(ASCIICode: dword);

var
  Cmd                  : tCmd_ASCIIEvent;

begin
  if CommConnected then
  begin
    XmtIndicator(sizeof(tCmd_ASCIIEvent));
    Cmd.cmd := ord(Cmd_ASCIIEvent);
    Cmd.ASCIICode := ASCIICode;
    WSocket_TMSRemote.Send(@Cmd, sizeof(tCmd_ASCIIEvent));
  end;
end;

procedure TForm1.SendReboot();

var
  Cmd                  : tCmd_Reboot;

begin
  if CommConnected then
  begin
    XmtIndicator(sizeof(tCmd_Reboot));
    Cmd.cmd := ord(Cmd_Reboot);
    WSocket_TMSRemote.Send(@Cmd, sizeof(tCmd_Reboot));
  end;
end;

procedure TForm1.GetVideoFrame();

var
  Cmd                  : tCmd_VideoFrame;

begin
  if CommConnected then
  begin
    XmtIndicator(sizeof(tCmd_VideoFrame));
    Cmd.cmd := ord(Cmd_VideoFrame);
    WSocket_TMSRemote.Send(@Cmd, sizeof(tCmd_VideoFrame));
  end;
end;

procedure TForm1.SendHideOsd(Hide: boolean);

var
  Cmd                  : tCmd_HideOsd;

begin
  if CommConnected then
  begin
    XmtIndicator(sizeof(tCmd_HideOsd));
    Cmd.cmd := ord(Cmd_HideOsd);
    if Hide then
      Cmd.HideOsd := 1
    else
      Cmd.HideOsd := 0;

    WSocket_TMSRemote.Send(@Cmd, sizeof(tCmd_HideOsd));
  end;
end;

procedure TForm1.ProcessOSDMacroblock(MacroBlock: pMacroBlock);
begin
  if MacroBlock.RLELength > 256 then
  begin
//    OutputDebugString('WSocket1DataAvailable: rejected packet due to invalid RLE length');
    inc(NWRcvBufferOut);
  end;

  if (NWRcvBufferIn - NWRcvBufferOut) < (8 + (Macroblock.RLELength shl 2)) then exit;

  //Copy the macro blocks into a cache
  //This will eliminate multiple occurences of the same pixel
  copymemory(@MacroBlockCache[MacroBlock.BlockIndex].MacroBlock, MacroBlock, 8 + (MacroBlock.RLELength shl 2));
  MacroBlockCache[MacroBlock.BlockIndex].Updated := true;

  //Update the draw pointer
  if MacroBlock.BlockIndex < CachePtr then CachePtr := MacroBlock.BlockIndex;

  inc(NWRcvBufferOut, 8 + (Macroblock.RLELength shl 2));
end;

procedure TForm1.DrawOSD();

var
  i                    : Integer;

begin
  for i := CachePtr to 1619 do
  begin
    if MacroBlockCache[i].Updated then
    begin
      if Panel_NWInfo.Visible then
        XiProgressBar4.Position := trunc(i*100/1619);
      DrawMacroBlock(@MacroBlockCache[i].MacroBlock, Image1);
      MacroBlockCache[i].Updated := false;
    end;
  end;
end;

procedure TForm1.InvalidateOSD();

var
  i                    : Integer;

begin
  CachePtr := 0;
  for i := CachePtr to 1619 do
    MacroBlockCache[i].Updated := true;
  DrawOsd();
end;

procedure TForm1.ProcessVideoMacroblock(MacroBlock: pMacroBlock);
begin
  if MacroBlock.RLELength > 256 then
  begin
//    OutputDebugString('WSocket1DataAvailable: rejected packet due to invalid RLE length');
    inc(NWRcvBufferOut);
  end;

  if (NWRcvBufferIn - NWRcvBufferOut) < (8 + (Macroblock.RLELength shl 2)) then exit;

  //Copy the macro blocks into a cache
  //This will eliminate multiple occurences of the same pixel
  dec(MacroBlock.BlockIndex, 3000);
  copymemory(@MacroBlockCacheVideo[MacroBlock.BlockIndex].MacroBlock, MacroBlock, 8 + (MacroBlock.RLELength shl 2));
  MacroBlockCacheVideo[MacroBlock.BlockIndex].Updated := true;
  MacroBlockCache[MacroBlock.BlockIndex].Updated := true;
  if MacroBlock.BlockIndex < CachePtr then CachePtr := MacroBlock.BlockIndex;

  inc(NWRcvBufferOut, 8 + (Macroblock.RLELength shl 2));

  VideoCaptured := true;
end;

procedure TForm1.DrawVideo();

var
  i                    : Integer;

begin
  for i := 0 to 1619 do
  begin
    if MacroBlockCacheVideo[i].Updated then
    begin
      if Panel_NWInfo.Visible then
        XiProgressBar4.Position := trunc(i*100/1619);
      DrawMacroBlock(@MacroBlockCacheVideo[i].MacroBlock, Image2);
      MacroBlockCacheVideo[i].Updated := false;
    end;
  end;
end;

procedure TForm1.ClearVideo();

var
  Rect                 : tRect;

begin
  Image2.Canvas.Brush.Color := BGColor;
  Rect.TopLeft := Point(0, 0);
  Rect.BottomRight := Point(720, 576);
  Image2.Canvas.FillRect(rect);
  Image2.Refresh();
  VideoCaptured := false;
end;

procedure TForm1.Panel_DirectModeClick(Sender: TObject);
begin
  DirectMode := not(DirectMode);
  if DirectMode then
  begin
    Panel_DirectMode.Font.Color := clBlack;
    Panel_DirectMode.Color := clLime;
    Panel_DirectMode.BevelOuter := bvLowered;
  end else
  begin
    Panel_DirectMode.Font.Color := clWhite;
    Panel_DirectMode.Color := clGreen;
    Panel_DirectMode.BevelOuter := bvRaised;
  end;
end;

procedure TForm1.ProcessMessage(MacroBlock: pMacroBlock);

var
  s                     : String;

begin
  if MacroBlock.RLELength > 256 then
  begin
//    OutputDebugString('WSocket1DataAvailable: rejected packet due to invalid RLE length');
    inc(NWRcvBufferOut);
  end;

  NWMessage := MacroBlock.RLEData[0].Blue;
  inc(NWRcvBufferOut, 8 + (Macroblock.RLELength shl 2));

  if NWMessage > -1 then
  begin
    case tMessageIDs(NWMessage) of

      MID_RecordingDialog:
      begin
        NWMessage := -1;
        s := 'Es luft gerade eine Aufnahme. Sobald der Aufnahme-Dialog angezeigt wird,'#13#10 +
             'kann der Topf nicht mehr ferngesteuert werden. Trotzdem Abschaltbefehl senden?';
        if MessageBox(Self.WindowHandle, pchar(s), 'TMSRemote', MB_YESNO) = IDYES then
          SendKeyEvent($1001000a);
      end;

      MID_AuthFailed:
      begin
        NWMessage := -1;
        DisconnectReason := DR_Auth;
        ImageShowText('Authentication failed', rgb(255,0,0));
      end;

      MID_DirectOn:
      begin
//        OutputDebugString('Timer1Timer: DirectMode on');
        if DirectMode = false then
          Panel_DirectModeClick(Self);
      end;

      MID_DirectOff:
      begin
//        OutputDebugString('Timer1Timer: DirectMode off');
        if DirectMode = true then
          Panel_DirectModeClick(Self);
      end;
    end;
  end;
end;

procedure TForm1.UpdateNWBufferInfo();
begin
  if Panel_NWInfo.Visible then
  begin
    XiProgressBar1.Position := trunc(NWRcvBufferIn * 100 / NWRcvBufferSize);
    XiProgressBar1.TextHeader := CyTools.FileSizeString(NWRcvBufferSize);
    XiProgressBar2.Position := trunc(NWRcvBufferOut * 100 / NWRcvBufferSize);
  end;
end;

procedure TForm1.SendIRCode(IRCode: word);

var
  Data                 : Array[0..8] of byte;
  CP                   : ^tConnectionProfile;
  TFIRInUse            : tSocketState;

begin
  if MultiInstance then exit;

  CP := @ConnectionProfile[CurrentConnectionProfile];
  if not(CP.TFIRInUse) then exit;

  Data[0] := $02;
  Data[1] := $01;
  Data[2] := $15;
  Data[3] := $00;

  case CP.TFIRRemoteMode of
    1:
    begin
      Data[4] := $40;
      Data[5] := $2c;
    end;

    2:
    begin
      Data[4] := $92;
      Data[5] := $00;
    end;

    3:
    begin
      Data[4] := $92;
      Data[5] := $99;
    end;

    4:
    begin
      Data[4] := $04;
      Data[5] := $fb;
    end;

    5:
    begin
      Data[4] := $0a;
      Data[5] := $80;
    end;
  end;

  Data[6] := IRCode shr 8;
  Data[7] := IRCode and $ff;
  Data[8] := $03;

  TFIRInUse := WSocket_TFIR.State;

  if TFIRInUse = wsClosed then
  begin
    WSocket_TFIR.Addr := CP.TFIRIP;
    WSocket_TFIR.Port := format('%d', [CP.TFIRPort]);
    WSocket_TFIR.LocalPort := WSocket_TFIR.Port;
    WSocket_TFIR.Proto := 'udp';
    WSocket_TFIR.Connect();
  end;

  WSocket_TFIR.Send(@Data[0], 9);

  if TFIRInUse = wsClosed then
    WSocket_TFIR.Close();
end;

{$REGION 'Socket'}
procedure TForm1.WSocket_TMSRemoteBgException(Sender: TObject; E: Exception; var CanClose: Boolean);
begin
//  OutputDebugString(pchar(Format('WSocket_TMSRemoteBgException: %s', [E.Message])));
end;

Function TForm1.SocketStateString(State: tSocketState): String;
begin
  case State of
    wsInvalidState:    Result := 'wsInvalidState';
    wsOpened:          Result := 'wsOpened';
    wsBound:           Result := 'wsBound';
    wsConnecting:      Result := 'wsConnecting';
    wsSocksConnected:  Result := 'wsSocksConnected';
    wsConnected:       Result := 'wsConnected';
    wsAccepting:       Result := 'wsAccepting';
    wsListening:       Result := 'wsListening';
    wsClosed:          Result := 'wsClosed';
  end;
end;

procedure TForm1.WSocket_TMSRemoteChangeState(Sender: TObject; OldState, NewState: TSocketState);
begin
//  OutputDebugString(pChar(Format('WSocket_TMSRemoteChangeState: %s -> %s', [SocketStateString(OldState), SocketStateString(NewState)])));
end;

procedure TForm1.WSocket_TMSRemoteDataAvailable(Sender: TObject; ErrCode: Word);

var
  Count                : Integer;
  Socket               : TWSocket;
  MacroBlock           : ^tMacroBlock;
  max                  : integer;

begin
  if ErrCode <> 0 then exit;
  CachePtr := 1620;
  max := 0;

  Socket := Sender as TWSocket;

  repeat
    UpdateNWBufferInfo();

    //Increase the receive buffer if necessary
    if (NWRcvBufferSize - NWRcvBufferIn) < Socket.SocketSndBufSize then
    begin
      NWRcvBufferSize := NWRcvBufferSize shl 1;
      SetLength(NWRcvBuffer, NWRcvBufferSize);
//      OutputDebugString(pchar(format('Increasing NWRcvBuffer to %d', [NWRcvBufferSize])));
    end;

    //Get all data from the network buffer
    if Socket.RcvdCount > max then max := Socket.RcvdCount;
    if Panel_NWInfo.Visible then
      XiProgressBar3.Position := trunc(max * 100 / Socket.SocketSndBufSize);

    Count := Socket.Receive(@NWRcvBuffer[NWRcvBufferIn], NWRcvBufferSize - NWRcvBufferIn);
    if(Count >= 0) then
    begin
      inc(NWRcvBufferIn, Count);
      RcvIndicator(Count);
    end;

    if (NWRcvBufferIn - NWRcvBufferOut) > 8 then
    begin
      Macroblock := @NWRcvBuffer[NWRcvBufferOut];

      if (MacroBlock.BlockIndex >= 0) and (MacroBlock.BlockIndex < NRMACROBLOCKS) then
        ProcessOSDMacroblock(@NWRcvBuffer[NWRcvBufferOut])
      else if (MacroBlock.BlockIndex >= 3000) and (MacroBlock.BlockIndex < (3000 + NRMACROBLOCKS)) then
        ProcessVideoMacroblock(@NWRcvBuffer[NWRcvBufferOut])
      else  if (MacroBlock.BlockIndex = 2000) then
        ProcessMessage(@NWRcvBuffer[NWRcvBufferOut])
      else begin
//        OutputDebugString('WSocket1DataAvailable: rejected packet due to invalid macro block index');
        inc(NWRcvBufferOut);
      end;
    end;
  until NWRcvBufferIn = NWRcvBufferOut;

  NWRcvBufferIn := 0;
  NWRcvBufferOut := 0;

  //Reset the receive buffer if it has been increased
  if NWRcvBufferSize <> DEFAULTBUFFERSIZE then
  begin
    NWRcvBufferSize := DEFAULTBUFFERSIZE;
    SetLength(NWRcvBuffer, NWRcvBufferSize);
    UpdateNWBufferInfo();
  end;

  DrawVideo();
  DrawOSD();

  if Panel_NWInfo.Visible then
    XiProgressBar4.Position := 0;
end;

procedure TForm1.WSocket_TMSRemoteDataSent(Sender: TObject; ErrCode: Word);
begin
//  OutputDebugString('WSocket_TMSRemoteDataSent');
end;

procedure TForm1.WSocket_TMSRemoteDnsLookupDone(Sender: TObject; ErrCode: Word);
begin
//  OutputDebugString('WSocket_TMSRemoteDnsLookupDone');
end;

procedure TForm1.WSocket_TMSRemoteError(Sender: TObject);
begin
//  with Sender as TWSocket do
//    OutputDebugString(pChar(Format('WSocket_TMSRemoteError: %d = %s', [LastError, WsocketErrorDesc(LastError)])));
end;

procedure TForm1.WSocket_TMSRemoteLineLimitExceeded(Sender: TObject; RcvdLength: Integer; var ClearData: Boolean);
begin
//  OutputDebugString('WSocket_TMSRemoteLineLimitExceeded');
end;

procedure TForm1.WSocket_TMSRemoteSessionConnected(Sender: TObject; ErrCode: Word);
begin
//  OutputDebugString('WSocket_TMSRemoteSessionConnected');
  CommConnected := true;
  WSocket_TMSRemote.SocketRcvBufSize := $20000;
  Button_Connect.Caption := 'Disconnect';
  Button_Connect.Enabled := true;
  SendAuthentication();
  SendHideOsd(CheckBox_HideOsd.Checked);
end;

procedure TForm1.WSocket_TMSRemoteSocksAuthState(Sender: TObject; AuthState: TSocksAuthState);
begin
//  OutputDebugString('WSocket_TMSRemoteSocksAuthState');
end;

procedure TForm1.WSocket_TMSRemoteSocksConnected(Sender: TObject; ErrCode: Word);
begin
//  OutputDebugString('WSocket_TMSRemoteSocksConnected');
end;

procedure TForm1.WSocket_TMSRemoteSocksError(Sender: TObject; Error: Integer; Msg: string);
begin
//  OutputDebugString('WSocket_TMSRemoteSocksError');
end;

procedure TForm1.WSocket_TMSRemoteSendData(Sender: TObject; BytesSent: Integer);
begin
//  OutputDebugString('WSocket_TMSRemoteSendData');
end;

procedure TForm1.WSocket_TMSRemoteSessionAvailable(Sender: TObject; ErrCode: Word);
begin
//  OutputDebugString('WSocket_TMSRemoteSessionAvailable');
end;

procedure TForm1.WSocket_TMSRemoteSessionClosed(Sender: TObject; ErrCode: Word);
begin
//  OutputDebugString('WSocket_TMSRemoteSessionClosed');
  CommConnected := false;
  Button_Connect.Caption := 'Connect';
  Button_Connect.Enabled := true;

  case DisconnectReason of
    DR_Normal: ImageShowText('Disconnected', rgb(255,0,0));
    DR_Auth:   ImageShowText('Authentication failed', rgb(255,0,0));
  end;

  NWXmt := 0;
  NWRcv := 0;
  Panel_NetworkXmt.Caption := format('Xmt=%s', [cytools.FileSizeString(NWRcv)]);
  Panel_NetworkRcv.Caption := format('Rcv=%s', [cytools.FileSizeString(NWRcv)]);
end;
{$ENDREGION}
{$ENDREGION}

end.

