/*
 * tap_debug.h
 *
 *  Created on: 13.09.2013
 *      Author: Josef
 */

#ifndef TAP_DEBUG_H_
#define TAP_DEBUG_H_

#ifdef i386

	#include                <stdio.h>

	#define DEBUG(...)      {printf(__VA_ARGS__); puts("") ;}

#else

	#include                <stdlib.h>
	#include                <string.h>

	extern void WriteLog(char *s);
	char                    LogPuffer[256];
	#define DEBUG(...)      {sprintf(LogPuffer, __VA_ARGS__); WriteLog(LogPuffer);}

#endif /* i386 */

#endif /* TAP_DEBUG_H_ */
